package com.glxp.mipsdl.admin.client.file;

import com.glxp.mipsdl.admin.client.BaseFileClient;
import com.glxp.mipsdl.admin.entity.phxyy.PhxyyCorpEntity;
import com.glxp.mipsdl.admin.entity.phxyy.PhxyyProductEntity;
import com.glxp.mipsdl.admin.req.system.PostThrCorpRequest;
import com.glxp.mipsdl.admin.req.system.PostThrProductsRequest;
import com.glxp.mipsdl.admin.res.system.UdiwmsProductInfoResponse;
import com.glxp.mipsdl.admin.res.system.UdiwmsUnitResponse;
import com.glxp.mipsdl.admin.thread.system.UdiInfoUploadService;
import com.glxp.mipsdl.common.res.BaseResponse;
import com.glxp.mipsdl.common.util.ExcelUtil;
import com.glxp.mipsdl.common.util.ResultVOUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;

@Service
public class PhxyyFileClient implements BaseFileClient {


    Logger logger = LoggerFactory.getLogger(ZyV1FileClient.class);
    @Resource
    UdiInfoUploadService udiInfoUploadService;

    @Override
    public BaseResponse uploadPi(List<MultipartFile> files, String thirdSys) {
        for (int i = 0; i < files.size(); i++) {
            MultipartFile file = files.get(i);
            if (file.isEmpty()) {
                return ResultVOUtils.error(500, "上传第" + (i++) + "个文件失败");
            }
            try {
                InputStream inputStream = file.getInputStream();
                ExcelUtil<PhxyyProductEntity> util = new ExcelUtil(PhxyyProductEntity.class);
                List<PhxyyProductEntity> phxyyProductEntities = util.importExcel("字典", inputStream);
                List<UdiwmsProductInfoResponse> udiwmsProductInfoResponses = new ArrayList<>();
                for (PhxyyProductEntity phxyyProductEntity : phxyyProductEntities) {
                    UdiwmsProductInfoResponse udiwmsProductInfoResponse = new UdiwmsProductInfoResponse();
                    BeanUtils.copyProperties(phxyyProductEntity, udiwmsProductInfoResponse);
                    udiwmsProductInfoResponses.add(udiwmsProductInfoResponse);
                }
                PostThrProductsRequest postThrProductsRequest = new PostThrProductsRequest();
                postThrProductsRequest.setDatas(udiwmsProductInfoResponses);
                postThrProductsRequest.setUploadType("文件导入");
                postThrProductsRequest.setThirdSys(thirdSys);
                udiInfoUploadService.postProducts(postThrProductsRequest);
                logger.error("上传完" + System.currentTimeMillis());
            } catch (IOException e) {
                e.printStackTrace();
                return ResultVOUtils.error(500, "数据异常");
            } catch (Exception e) {
                e.printStackTrace();
                return ResultVOUtils.error(500, "数据异常");
            }
        }
        return ResultVOUtils.success("文件解析成功，正在上传，请稍后刷新查看");
    }

    @Override
    public BaseResponse uploadCorps(List<MultipartFile> files, String thirdSys) {
        for (int i = 0; i < files.size(); i++) {
            MultipartFile file = files.get(i);
            if (file.isEmpty()) {
                return ResultVOUtils.error(500, "上传第" + (i++) + "个文件失败");
            }
            List<UdiwmsUnitResponse> udiwmsUnitResponses = new ArrayList<>();
            try {
                InputStream inputStream = file.getInputStream();
                ExcelUtil<PhxyyCorpEntity> util = new ExcelUtil(PhxyyCorpEntity.class);
                List<PhxyyCorpEntity> phxyyCorpEntities = util.importExcel("单位", inputStream);
                for (PhxyyCorpEntity phxyyCorpEntity : phxyyCorpEntities) {
                    UdiwmsUnitResponse udiwmsUnitResponse = new UdiwmsUnitResponse();
                    udiwmsUnitResponse.setName(phxyyCorpEntity.getCorpName());
                    udiwmsUnitResponse.setUnitId(phxyyCorpEntity.getCorpCode());
                    udiwmsUnitResponses.add(udiwmsUnitResponse);
                }
                PostThrCorpRequest postThrProductsRequest = new PostThrCorpRequest();
                postThrProductsRequest.setCorps(udiwmsUnitResponses);
                postThrProductsRequest.setThirdSys(thirdSys);
                udiInfoUploadService.postCorps(postThrProductsRequest);
            } catch (IOException e) {
                e.printStackTrace();
                return ResultVOUtils.error(500, "数据异常");
            } catch (Exception e) {
                e.printStackTrace();
                return ResultVOUtils.error(500, "数据异常");
            }
        }
        return ResultVOUtils.success("文件解析成功，正在上传，请稍后刷新查看");
    }

    @Override
    public BaseResponse uploadInvPi(List<MultipartFile> files, String thirdSys) {
        return ResultVOUtils.error(500, "暂不支持库存产品信息上传！");
    }

    @Override
    public BaseResponse uploadOrders(List<MultipartFile> files, String thirdSys) {
        return ResultVOUtils.error(500, "暂不支持业务单据上传！");
    }
}
