package com.glxp.mipsdl.admin.client.http;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.ReflectUtil;
import cn.hutool.core.util.StrUtil;
import cn.hutool.json.JSONUtil;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.TypeReference;
import com.glxp.mipsdl.admin.config.ThirdSysConfig;
import com.glxp.mipsdl.admin.constant.ConstantStatus;
import com.glxp.mipsdl.admin.constant.ConstantType;
import com.glxp.mipsdl.admin.dao.auth.AuthAdminDao;
import com.glxp.mipsdl.admin.dao.basic.*;
import com.glxp.mipsdl.admin.dao.business.StockOrderDao;
import com.glxp.mipsdl.admin.dao.business.StockOrderDetailDao;
import com.glxp.mipsdl.admin.dao.business.StockOrderUploadLogDao;
import com.glxp.mipsdl.admin.dao.inout.CodesDao;
import com.glxp.mipsdl.admin.dao.inout.OrderDao;
import com.glxp.mipsdl.admin.dao.inventory.InvWarehouseDao;
import com.glxp.mipsdl.admin.dao.phxyy.BasicThirdSysDetailDao;
import com.glxp.mipsdl.admin.dao.thrsys.ThrInvWarehouseDao;
import com.glxp.mipsdl.admin.entity.auth.AuthAdmin;
import com.glxp.mipsdl.admin.entity.basic.BasicThirdSysBusApiEntity;
import com.glxp.mipsdl.admin.entity.basic.BussinessLocalTypeEntity;
import com.glxp.mipsdl.admin.entity.basic.UdiRelevanceEntity;
import com.glxp.mipsdl.admin.entity.basic.UnitMaintainEntity;
import com.glxp.mipsdl.admin.entity.business.StockOrderDetailEntity;
import com.glxp.mipsdl.admin.entity.business.StockOrderEntity;
import com.glxp.mipsdl.admin.entity.business.StockOrderUploadLogEntity;
import com.glxp.mipsdl.admin.entity.inout.OrderEntity;
import com.glxp.mipsdl.admin.entity.inout.WarehouseEntity;
import com.glxp.mipsdl.admin.entity.inventory.InvWarehouseEntity;
import com.glxp.mipsdl.admin.entity.phxyy.BasicThirdSysDetailEntity;
import com.glxp.mipsdl.admin.entity.thrsys.ThrInvWarehouseEntity;
import com.glxp.mipsdl.admin.entity.zy.ZaZyHeareRequest;
import com.glxp.mipsdl.admin.req.*;
import com.glxp.mipsdl.admin.req.basic.BussinessLocalTypeFilterRequest;
import com.glxp.mipsdl.admin.req.phxyy.PhBusTypeRequest;
import com.glxp.mipsdl.admin.req.phxyy.PhProductRequest;
import com.glxp.mipsdl.admin.req.phxyy.PhUnitRequest;
import com.glxp.mipsdl.admin.req.phxyy.PhWarehouseRequest;
import com.glxp.mipsdl.admin.req.thrsys.FilterThrInvWarehouseRequest;
import com.glxp.mipsdl.admin.util.DateUtil;
import com.glxp.mipsdl.admin.util.HttpClient;
import com.glxp.mipsdl.common.res.BaseResponse;
import com.glxp.mipsdl.common.util.ResultVOUtils;
import lombok.extern.slf4j.Slf4j;
import org.dom4j.Document;
import org.dom4j.DocumentException;
import org.dom4j.DocumentHelper;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@Slf4j
@Service
public class ZaxyyClient {

    @Resource
    private ThirdSysConfig thirdSysConfig;
    @Resource
    private HttpClient httpClient;
    @Resource
    private StockOrderDao stockOrderDao;
    @Resource
    private StockOrderDetailDao stockOrderDetailDao;
    @Resource
    private BussinessLocalTypeDao bussinessLocalTypeDao;
    @Resource
    private BasicThirdSysBusApiDao thirdSysBusApiDao;
    @Resource
    private InvWarehouseDao invWarehouseDao;
    @Resource
    private ThrInvWarehouseDao thrInvWarehouseDao;
    @Resource
    private UnitMaintainDao unitMaintainDao;
    @Resource
    private BussinessTypeDao bussinessTypeDao;
    @Resource
    private BasicThirdSysDetailDao basicThirdSysDetailDao;
    @Resource
    private CodesDao codesDao;
    @Resource
    private UdiRelevanceDao udiRelevanceDao;
    @Resource
    private AuthAdminDao authAdminDao;
    @Resource
    private OrderDao orderDao;
    @Resource
    private StockOrderUploadLogDao stockOrderUploadLogDao;

    String[] getHeaderArray() {
        List<String> headArray = new ArrayList<>();
        headArray.add("Content-Type");
        headArray.add("application/json");
        if (StrUtil.isNotEmpty(thirdSysConfig.getThirdSysConfig().getApikey())) {
            headArray.add("api_key");
            headArray.add(thirdSysConfig.getThirdSysConfig().getApikey());
        }
        if (StrUtil.isNotEmpty(thirdSysConfig.getThirdSysConfig().getSecretkey())) {
            headArray.add("secret_key");
            headArray.add(thirdSysConfig.getThirdSysConfig().getSecretkey());
        }
        String[] strArray = new String[headArray.size()];
        headArray.toArray(strArray);
        return strArray;
    }


    public BaseResponse testConnect() {
        String msgHead = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" +
                "<root>" +
                "<serverName>getMasterialInput</serverName>" +
                "</root>";


        String msgBody = "{\"billNo\":\"ZY202205070001\",\"billdate\":\"2022-05-07\",\"corpId\":\"65119908299161\",\"corpName\":\"福建片仔癀诊断技术有限公司\",\"billType\":\"采购入库\",\"billFlag\":\"1\",\"thirdSys\":\"thirdId\",\"locInvCode\":\"11001\",\"locInvName\":\"总仓库\",\"inoutType\":\"1\",\"remark\":\"\",\"item\":[{\"billNo\":\"ZY202205070001\",\"productId\":\"7864\",\"productName\":\"通用脊柱内固定器-6.0 连接棒\",\"standard\":\"70-450mm/理贝尔\",\"expireDate\":\"2025-01-03\",\"productDate\":\"2021-03-01\",\"batchNo\":\"202003\",\"count\":10,\"measname\":\"计量单位\",\"registerNo\":\"国食药监械（准）字 2006 第 3460057 号\",\"price\":10.0,\"secSalesInvNo\":\"21232424\",\"invoiceDate\":\"2323243\",\"secSalesListNo\":\"42342\",\"firstSalesInvNo\":\"423424\",\"remark\":\"\",\"remakr1\":\"\",\"remakr2\":\"\",\"codeList\":[{\"code\":\"01069125473843801121041410210290075\",\"nameCode\":\"06912547384380\",\"count\":1}]},{\"productId\":\"7901\",\"productName\":\"亲水性丙烯酸折叠式人工晶状体 Hydrophilic AcrylicFoldableIntraocular Lens\",\"standard\":\"S1AW00\",\"batchNo\":\"202103\",\"expireDate\":\"2025-01-03\",\"productDate\":\"2021-03-01\",\"count\":10,\"measname\":\"计量单位\",\"registerNo\":\"国械注进 20153162635\",\"price\":10.0,\"secSalesInvNo\":\"21232424\",\"invoiceDate\":\"2323243\",\"secSalesListNo\":\"42342\",\"firstSalesInvNo\":\"423424\",\"remark\":\"\",\"remakr1\":\"\",\"remakr2\":\"\",\"codeList\":[{\"code\":\"01069125473843801121041410210290075\",\"nameCode\":\"06912547384380\",\"count\":1}]}]}";

        ZaZyHeareRequest zaZyHeareRequest = new ZaZyHeareRequest();
        zaZyHeareRequest.setMsgHeader(msgHead);
        zaZyHeareRequest.setMsgBody(msgBody);
        String response = httpClient.postJson(thirdSysConfig.getThirdSysConfig().getThirdSysUrl(), zaZyHeareRequest, getHeaderArray());
        log.info(response);
        return ResultVOUtils.error(500, "连接成功！");
    }


    public String getMsgHeader(String methodName) {
        String msgHead = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" +
                "<root>" +
                "<serverName>" +
                methodName +
                "</serverName>" +
                "</root>";
        return msgHead;
    }

    public BaseResponse getUnit(PhUnitRequest unitRequest) {
        BasicThirdSysDetailEntity basicThirdSysDetailEntity = basicThirdSysDetailDao.selectByKey("corpUrl", thirdSysConfig.getThirdSysConfig().getThirdId());
        ZaZyHeareRequest zaZyHeareRequest = new ZaZyHeareRequest();
        zaZyHeareRequest.setMsgHeader(getMsgHeader("getMaterialUnit"));
        zaZyHeareRequest.setMsgBody(JSONUtil.toJsonStr(unitRequest));
        String response = httpClient.postJson(thirdSysConfig.getThirdSysConfig().getThirdSysUrl() + basicThirdSysDetailEntity.getValue(), zaZyHeareRequest, getHeaderArray());
        response = parseErrorMsg(response);
        try {
            BaseResponse baseResponse =
                    JSONObject.parseObject(response, new TypeReference<BaseResponse>() {
                    });

            return baseResponse;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return ResultVOUtils.error(500, "网络错误，或远程服务器异常无法返回正确结果" + "（" + response + ")");
    }

    public BaseResponse getProducts(PhProductRequest udiwmsProductRequest) {
        BasicThirdSysDetailEntity basicThirdSysDetailEntity = basicThirdSysDetailDao.selectByKey("piQueryUrl", thirdSysConfig.getThirdSysConfig().getThirdId());

        ZaZyHeareRequest zaZyHeareRequest = new ZaZyHeareRequest();
        zaZyHeareRequest.setMsgHeader(getMsgHeader("getMaterialDict"));
        zaZyHeareRequest.setMsgBody(JSONUtil.toJsonStr(udiwmsProductRequest));

        String response = httpClient.postJson(thirdSysConfig.getThirdSysConfig().getThirdSysUrl() + basicThirdSysDetailEntity.getValue(), zaZyHeareRequest, getHeaderArray());
        response = parseErrorMsg(response);
        try {
            BaseResponse baseResponse =
                    JSONObject.parseObject(response, new TypeReference<BaseResponse>() {
                    });
            return baseResponse;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return ResultVOUtils.error(500, "网络错误，或远程服务器异常无法返回正确结果" + "（" + response + ")");
    }

    public BaseResponse getOrderTypes(PhBusTypeRequest udiwmsBusTypeRequest) {
        BasicThirdSysDetailEntity basicThirdSysDetailEntity = basicThirdSysDetailDao.selectByKey("busTypeQueryUrl", thirdSysConfig.getThirdSysConfig().getThirdId());

        ZaZyHeareRequest zaZyHeareRequest = new ZaZyHeareRequest();
        zaZyHeareRequest.setMsgHeader(getMsgHeader("getMaterialType"));
        zaZyHeareRequest.setMsgBody(JSONUtil.toJsonStr(udiwmsBusTypeRequest));


        String response = httpClient.postJson(thirdSysConfig.getThirdSysConfig().getThirdSysUrl() + basicThirdSysDetailEntity.getValue(), zaZyHeareRequest, getHeaderArray());
        response = parseErrorMsg(response);
        try {
            BaseResponse baseResponse =
                    JSONObject.parseObject(response, new TypeReference<BaseResponse>() {
                    });
            return baseResponse;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return ResultVOUtils.error(500, "网络错误，或远程服务器异常无法返回正确结果" + "（" + response + ")");
    }

    public BaseResponse getOrders(UdiwmsOrderRequest udiwmsOrderRequest) {


//        if (StrUtil.isEmpty(udiwmsOrderRequest.getBillType())) {
//            return ResultVOUtils.error(500, "单据类型不能未空");
//        }
//        if (StrUtil.isEmpty(udiwmsOrderRequest.getThirdSys())) {
//            return ResultVOUtils.error(500, "第三方系统ID不能为空");
//        }
//        BussinessOriginTypeResponse bussinessOriginTypeResponse = bussinessOriginTypeService.findByKey(udiwmsOrderRequest.getBillType(), thirdSysConfig.getThirdSysConfig().getThirdId());
//        udiwmsOrderRequest.setBillType(bussinessOriginTypeResponse.getThirdAction());

        ZaZyHeareRequest zaZyHeareRequest = new ZaZyHeareRequest();
        zaZyHeareRequest.setMsgHeader(getMsgHeader("getMaterialApply"));
        zaZyHeareRequest.setMsgBody(JSONUtil.toJsonStr(udiwmsOrderRequest));

//        BasicThirdSysBusApiEntity basicThirdSysBusApiEntity = basicThirdSysBusApiService.selectByKey(bussinessOriginTypeResponse.getThirdAction(), bussinessOriginTypeResponse.getThirdSys(), 1);
        BasicThirdSysDetailEntity basicThirdSysDetailEntity = basicThirdSysDetailDao.selectByKey("orderQueryUrl", thirdSysConfig.getThirdSysConfig().getThirdId());
        String response = httpClient.postJson(thirdSysConfig.getThirdSysConfig().getThirdSysUrl() + basicThirdSysDetailEntity.getValue(), zaZyHeareRequest, getHeaderArray());
        response = parseErrorMsg(response);
        try {
            BaseResponse baseResponse =
                    JSONObject.parseObject(response, new TypeReference<BaseResponse>() {
                    });
            return baseResponse;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return ResultVOUtils.error(500, "网络错误，或远程服务器异常无法返回正确结果" + "（" + response + ")");
    }

    public BaseResponse submitOrders(ZaxzyyOrderRequest udiwmsOrderRequest) {
        if (StrUtil.isEmpty(udiwmsOrderRequest.getId())) {
            return ResultVOUtils.error(500, "单据ID不能为空！");
        }
        //查询单据和详情信息，组装第三方系统接口参数所需数据
        StockOrderEntity stockOrderEntity = stockOrderDao.findById(udiwmsOrderRequest.getId());
        List<StockOrderDetailEntity> stockOrderDetailEntities = stockOrderDetailDao.findByOrderIdFk(stockOrderEntity.getId());

        udiwmsOrderRequest.setBillDate(stockOrderEntity.getBilldate());
        udiwmsOrderRequest.setBillNo(stockOrderEntity.getBillNo());

        BussinessLocalTypeFilterRequest bussinessLocalTypeFilterRequest = new BussinessLocalTypeFilterRequest();
        bussinessLocalTypeFilterRequest.setAction(stockOrderEntity.getBillType());
        List<BussinessLocalTypeEntity> bussinessLocalTypeEntities = bussinessLocalTypeDao.filterJoin(bussinessLocalTypeFilterRequest);
        BussinessLocalTypeEntity bussinessLocalTypeEntity = bussinessLocalTypeEntities.get(0);

        //查询第三方系统的单据ID，及第三方系统标识
        BasicThirdSysBusApiEntity thirdSysBusApiEntity = thirdSysBusApiDao.selectByCode(stockOrderEntity.getBillType());
        if (StrUtil.isBlank(thirdSysBusApiEntity.getUrl())) {
            return ResultVOUtils.error(500, "接口未配置，无法提交！");
        }
        String thirdId = getThirdId(thirdSysBusApiEntity);
        udiwmsOrderRequest.setThirdSys(thirdId); //第三方系统标识
        udiwmsOrderRequest.setBillType(thirdSysBusApiEntity.getThirdBuyCode());

        if (bussinessLocalTypeEntity.getCorpType() == ConstantStatus.CORP_TYPE_INPUT) {
            udiwmsOrderRequest.setCorpId(stockOrderEntity.getCorpName()); //往来单位编码，需转换为第三方系统的ID
            udiwmsOrderRequest.setCorpName(stockOrderEntity.getCorpName()); //往来单位名称，需转换为第三方系统的名称
        } else if (bussinessLocalTypeEntity.getCorpType() == ConstantStatus.CORP_TYPE_INNOR) {
            List<InvWarehouseEntity> invWarehouseEntities = invWarehouseDao.selectByCode(stockOrderEntity.getCorpId());
            InvWarehouseEntity invWarehouseEntity = invWarehouseEntities.get(0);
            try {
                //根据第三方系统标识，获取对应字段的值
                FilterThrInvWarehouseRequest filterThrInvWarehouseRequest = new FilterThrInvWarehouseRequest();
                filterThrInvWarehouseRequest.setCode(invWarehouseEntity.getThirdId());
                filterThrInvWarehouseRequest.setThirdSysFk(thirdId);
                List<ThrInvWarehouseEntity> thrInvWarehouseEntities = thrInvWarehouseDao.filterThrInvWarehouse(filterThrInvWarehouseRequest);
                ThrInvWarehouseEntity thrInvWarehouseEntity = thrInvWarehouseEntities.get(0);
                udiwmsOrderRequest.setCorpId(thrInvWarehouseEntity.getCode()); //往来单位编码，需转换为第三方系统的ID
                udiwmsOrderRequest.setCorpName(thrInvWarehouseEntity.getName()); //往来单位名称，需转换为第三方系统的名称
            } catch (Exception e) {
                log.error("查询单据对应的第三方往来单位信息异常", e);
            }
        } else if (bussinessLocalTypeEntity.getCorpType() == ConstantStatus.CORP_TYPE_OUT) {
            //查询往来单位第三方系统对照编码
            UnitMaintainEntity unitMaintainEntity = unitMaintainDao.selectThirdInfoByErpId(stockOrderEntity.getCorpId());
            try {
                String thirdCorpId = (String) ReflectUtil.getFieldValue(unitMaintainEntity, unitMaintainEntity.getClass().getField(thirdId));
                udiwmsOrderRequest.setCorpId(thirdCorpId); //往来单位编码，需转换为第三方系统的ID

                String thirdName = getThirdName(thirdId);
                String thirdCorpName = (String) ReflectUtil.getFieldValue(unitMaintainEntity, unitMaintainEntity.getClass().getField(thirdName));
                udiwmsOrderRequest.setCorpName(thirdCorpName); //往来单位名称，需转换为第三方系统的名称
            } catch (Exception e) {
                log.error(e.getMessage(), e);
            }
        }

        InvWarehouseEntity invWarehouseEntity = invWarehouseDao.selectOneByCode(stockOrderEntity.getLocStorageCode());
        try {
            ThrInvWarehouseEntity thrInvWarehouseEntity = thrInvWarehouseDao.selectByCode(invWarehouseEntity.getThirdId(), thirdId);
            udiwmsOrderRequest.setLocStorageCode(thrInvWarehouseEntity.getCode());
            udiwmsOrderRequest.setLocStorageName(thrInvWarehouseEntity.getName());
        } catch (Exception e) {
            log.error("查询第三方系统仓库异常", e);
        }

        udiwmsOrderRequest.setBillFlag(stockOrderEntity.getBillFlag()); //单据状态

        //查询单据出入库类型
        String mainAction = bussinessTypeDao.selectInoutTypebByLocalAction(stockOrderEntity.getBillType());
        if (ConstantType.TYPE_PUT.equals(mainAction)) {
            udiwmsOrderRequest.setInoutType(1); //出入库类型：入库
        } else if (ConstantType.TYPE_OUT.equals(mainAction)) {
            udiwmsOrderRequest.setInoutType(2); //出入库类型：出库
        }

        udiwmsOrderRequest.setRemark("udi管理系统提交单据"); //备注

        //组装明细数据
        List<WarehouseEntity> warehouseEntities = codesDao.findByReceiptId(stockOrderEntity.getOrderIdFk());
        List<UdiwmsOrderDetail> items = new ArrayList<>(stockOrderDetailEntities.size());
        for (StockOrderDetailEntity stockOrderDetailEntity : stockOrderDetailEntities) {
            UdiRelevanceEntity udiRelevanceEntity = udiRelevanceDao.selectById(stockOrderDetailEntity.getRelId());
            UdiwmsOrderDetail item = new UdiwmsOrderDetail();
            BeanUtil.copyProperties(stockOrderDetailEntity, item);
            if (StrUtil.isNotEmpty(stockOrderDetailEntity.getProductDate())) {
                item.setProductDate(DateUtil.formatExpireTime("20" + stockOrderDetailEntity.getProductDate()));
            }
            if (StrUtil.isNotEmpty(stockOrderDetailEntity.getExpireDate())) {
                item.setExpireDate(DateUtil.formatExpireTime("20" + stockOrderDetailEntity.getExpireDate()));
            }

            item.setMeasname(udiRelevanceEntity.getMeasname());
            item.setStandard(stockOrderDetailEntity.getSpec());
            item.setRegisterNo(stockOrderDetailEntity.getZczbhhzbapzbh());
            List<WarehouseEntity> warehouseEntityList = filterCodes(stockOrderDetailEntity, warehouseEntities);
            if (CollUtil.isNotEmpty(warehouseEntityList)) {
                List<UdiwmsOrderDetail.CodeDetaiEntity> codeDetaiEntities = new ArrayList<>();
                warehouseEntityList.forEach(warehouseEntity -> {
                    UdiwmsOrderDetail.CodeDetaiEntity codeDetaiEntity = new UdiwmsOrderDetail.CodeDetaiEntity();
                    BeanUtils.copyProperties(warehouseEntity, codeDetaiEntity);
                    codeDetaiEntities.add(codeDetaiEntity);
                });
                item.setCodeList(codeDetaiEntities);
            }
            try {
                String thirdProductId = (String) ReflectUtil.getFieldValue(udiRelevanceEntity, thirdId);
                item.setProductId(thirdProductId);

                String thirdName = getThirdName(thirdId);
                String thirdProductName = (String) ReflectUtil.getFieldValue(udiRelevanceEntity, thirdName);
                item.setProductName(thirdProductName);
                items.add(item);
            } catch (Exception e) {
                log.error(e.getMessage(), e);
            }
        }

        udiwmsOrderRequest.setItem(items);

        //查询扫码单据
        OrderEntity orderEntity = orderDao.findById(stockOrderEntity.getOrderIdFk());

        ZaZyHeareRequest zaZyHeareRequest = new ZaZyHeareRequest();

        String key = null;
        //提交订单到第三方系统
        if (thirdSysBusApiEntity.getUrl().equals("saveMasterialInput")) {
            //采购入库单据
            zaZyHeareRequest.setMsgHeader(getMsgHeader("saveMasterialInput"));
            key = "orderSubmitUrl";
            zaZyHeareRequest.setMsgBody(JSONUtil.toJsonStr(udiwmsOrderRequest));
        } else if (thirdSysBusApiEntity.getUrl().equals("saveMaterialHight")) {
            //临床出库
            udiwmsOrderRequest.setLocInvCode(udiwmsOrderRequest.getLocStorageCode());
            udiwmsOrderRequest.setLocInvName(udiwmsOrderRequest.getLocStorageName());
            zaZyHeareRequest.setMsgHeader(getMsgHeader("saveMaterialHight"));
            key = "preInOrderSubmit";

            UdiwmsPreInOrderRequest udiwmsPreInOrderRequest = submitPreInOrderToThirdSys(udiwmsOrderRequest, orderEntity);
            zaZyHeareRequest.setMsgBody(JSONUtil.toJsonStr(udiwmsPreInOrderRequest));

        }

        BasicThirdSysDetailEntity basicThirdSysDetailEntity = basicThirdSysDetailDao.selectByOrderType(key, thirdSysConfig.getThirdSysConfig().getThirdId(), udiwmsOrderRequest.getBillType());

        String interStr = "";
        if (StrUtil.isNotEmpty(basicThirdSysDetailEntity.getOrderTypeUrl())) {
            interStr = basicThirdSysDetailEntity.getOrderTypeUrl();

        } else {
            interStr = basicThirdSysDetailEntity.getValue();
        }

        //记录日志
        StockOrderUploadLogEntity uploadLog = new StockOrderUploadLogEntity();
        uploadLog.setBillDate(DateUtil.parseDate(udiwmsOrderRequest.getBillDate()));
        uploadLog.setBillType(stockOrderEntity.getBillType());
        uploadLog.setSubmitTime(new Date());
        uploadLog.setBillNo(udiwmsOrderRequest.getBillNo());
        uploadLog.setFromType(ConstantStatus.THIRD_ORDER_UPLOAD);
        String response = httpClient.postJson(thirdSysConfig.getThirdSysConfig().getThirdSysUrl() + interStr, zaZyHeareRequest, getHeaderArray());
        response = parseErrorMsg(response);
        if (StrUtil.isNotBlank(response)) {
            try {
                BaseResponse baseResponse =
                        JSONObject.parseObject(response, new TypeReference<BaseResponse>() {
                        });
                if (baseResponse.getCode().equals(20000)) {
                    String thirdBillNo = String.valueOf(baseResponse.getData());
                    orderEntity.setExportStatus(1);
                    orderEntity.setThirdBillNo(thirdBillNo);
                    uploadLog.setStatus(2);
                    uploadLog.setThrBillNo(null);
                    uploadLog.setResult("提交成功");
                    stockOrderUploadLogDao.insert(uploadLog);
                    return ResultVOUtils.success("提交成功");
                }
                uploadLog.setStatus(3);
                uploadLog.setResult("提交失败，错误信息：" + baseResponse.getMessage());
                stockOrderUploadLogDao.insert(uploadLog);
                return baseResponse;
            } catch (Exception e) {
                log.error(e.getMessage(), e);
                uploadLog.setStatus(3);
                uploadLog.setResult("提交失败，错误信息：" + e.getMessage());
                stockOrderUploadLogDao.insert(uploadLog);
                return ResultVOUtils.error(500, "提交失败");
            }
        } else {
            uploadLog.setStatus(3);
            uploadLog.setResult("提交失败，调用接口返回为空");
            stockOrderUploadLogDao.insert(uploadLog);
            return ResultVOUtils.error(500, "提交失败");
        }
    }


    public BaseResponse submitPreInOrders(UdiwmsPreInOrderRequest udiwmsPreInOrderRequest) {


        BasicThirdSysDetailEntity basicThirdSysDetailEntity = basicThirdSysDetailDao.selectByKey("preInOrderSubmit", thirdSysConfig.getThirdSysConfig().getThirdId());
        String interStr = "";
        interStr = basicThirdSysDetailEntity.getValue();

        ZaZyHeareRequest zaZyHeareRequest = new ZaZyHeareRequest();
        zaZyHeareRequest.setMsgHeader(getMsgHeader("saveMaterialHight"));
        zaZyHeareRequest.setMsgBody(JSONUtil.toJsonStr(udiwmsPreInOrderRequest));

        String response = httpClient.postJson(thirdSysConfig.getThirdSysConfig().getThirdSysUrl() + interStr, zaZyHeareRequest, getHeaderArray());
        response = parseErrorMsg(response);
        try {
            BaseResponse baseResponse =
                    JSONObject.parseObject(response, new TypeReference<BaseResponse>() {
                    });
            return baseResponse;
        } catch (Exception e) {
            e.printStackTrace();
        }

        return ResultVOUtils.error(500, "网络错误，或远程服务器异常无法返回正确结果" + "（" + response + ")");
    }

    public BaseResponse getInvProducts(UdiwmsOnhandRequest udiwmsOnhandRequest) {
        BasicThirdSysDetailEntity basicThirdSysDetailEntity = basicThirdSysDetailDao.selectByKey("invPiUrl", thirdSysConfig.getThirdSysConfig().getThirdId());
        ZaZyHeareRequest zaZyHeareRequest = new ZaZyHeareRequest();
        zaZyHeareRequest.setMsgHeader(getMsgHeader("getMaterialStorage"));
        zaZyHeareRequest.setMsgBody(JSONUtil.toJsonStr(udiwmsOnhandRequest));
        String response = httpClient.postJson(thirdSysConfig.getThirdSysConfig().getThirdSysUrl() + basicThirdSysDetailEntity.getValue(), zaZyHeareRequest, getHeaderArray());
        response = parseErrorMsg(response);
        try {
            BaseResponse baseResponse =
                    JSONObject.parseObject(response, new TypeReference<BaseResponse>() {
                    });
            return baseResponse;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return ResultVOUtils.error(500, "网络错误，或远程服务器异常无法返回正确结果" + "（" + response + ")");
    }

    public BaseResponse getWarehouse(PhWarehouseRequest udiwmsWarehouseRequest) {

        ZaZyHeareRequest zaZyHeareRequest = new ZaZyHeareRequest();
        zaZyHeareRequest.setMsgHeader(getMsgHeader("getMaterialDept"));
        zaZyHeareRequest.setMsgBody(JSONUtil.toJsonStr(udiwmsWarehouseRequest));

        BasicThirdSysDetailEntity basicThirdSysDetailEntity = basicThirdSysDetailDao.selectByKey("warehouseQueryUrl", thirdSysConfig.getThirdSysConfig().getThirdId());
        String response = httpClient.postJson(thirdSysConfig.getThirdSysConfig().getThirdSysUrl() + basicThirdSysDetailEntity.getValue(), zaZyHeareRequest, getHeaderArray());
        response = parseErrorMsg(response);
        try {
            BaseResponse baseResponse =
                    JSONObject.parseObject(response, new TypeReference<BaseResponse>() {
                    });
            return baseResponse;
        } catch (
                Exception e) {
            e.printStackTrace();
        }
        return ResultVOUtils.error(500, "网络错误，或远程服务器异常无法返回正确结果" + "（" + response + ")");
    }

    public List<WarehouseEntity> filterCodes(StockOrderDetailEntity stockOrderDetailEntity, List<WarehouseEntity> warehouseEntities) {
        List<WarehouseEntity> results = new ArrayList<>();
        if (CollUtil.isNotEmpty(warehouseEntities)) {
            for (WarehouseEntity warehouseEntity : warehouseEntities) {
                if (StrUtil.trimToEmpty(warehouseEntity.getRelId()).equals(StrUtil.trimToEmpty(stockOrderDetailEntity.getRelId()))
                        && StrUtil.trimToEmpty(warehouseEntity.getBatchNo()).equals(StrUtil.trimToEmpty(stockOrderDetailEntity.getBatchNo()))
                ) {
                    results.add(warehouseEntity);
                }
            }
        }
        return results;
    }

    public UdiwmsPreInOrderRequest submitPreInOrderToThirdSys(ZaxzyyOrderRequest udiwmsOrderRequest, OrderEntity orderEntity) {

        UdiwmsPreInOrderRequest udiwmsPreInOrderRequest = new UdiwmsPreInOrderRequest();
        if (udiwmsOrderRequest != null) {
            BeanUtils.copyProperties(udiwmsOrderRequest, udiwmsPreInOrderRequest);
            udiwmsPreInOrderRequest.setLocInvCode(udiwmsOrderRequest.getLocStorageCode());
            udiwmsPreInOrderRequest.setLocInvName(udiwmsOrderRequest.getLocStorageName());
            if (orderEntity.getReviewUser() != null) {
                AuthAdmin authAdmin = authAdminDao.findById(orderEntity.getReviewUser().longValue());
                udiwmsPreInOrderRequest.setActor(authAdmin.getEmployeeName());
            } else if (orderEntity.getCreateUser() != null) {
                AuthAdmin authAdmin = authAdminDao.findById(orderEntity.getCreateUser().longValue());
                udiwmsPreInOrderRequest.setActor(authAdmin.getEmployeeName());
            }
            List<UdiwmsPreInOrderRequest.ItemDTO> itemDTOS = new ArrayList<>();
            if (CollUtil.isNotEmpty(udiwmsOrderRequest.getItem())) {
                for (UdiwmsOrderDetail udiwmsOrderDetail : udiwmsOrderRequest.getItem()) {
                    if (CollUtil.isNotEmpty(udiwmsOrderDetail.getCodeList())) {
                        for (UdiwmsOrderDetail.CodeDetaiEntity codeDetaiEntity : udiwmsOrderDetail.getCodeList()) {
                            UdiwmsPreInOrderRequest.ItemDTO itemDTO = new UdiwmsPreInOrderRequest.ItemDTO();
                            BeanUtils.copyProperties(udiwmsOrderDetail, itemDTO);
                            itemDTO.setCode(codeDetaiEntity.getCode());
                            itemDTO.setCount(codeDetaiEntity.getCount());
                            itemDTOS.add(itemDTO);

                        }
                    }
                }
            }
            udiwmsPreInOrderRequest.setItems(itemDTOS);

        }

        return udiwmsPreInOrderRequest;
    }

    public String parseErrorMsg(String response) {
        if (response.contains("<root")) {
            try {
                Document document = DocumentHelper.parseText(response);
                String message = document.getRootElement().element("message").getText();
                return message;
            } catch (DocumentException e) {
                e.printStackTrace();
            }
        }
        return response;
    }

    /**
     * 获取第三方名称字段
     *
     * @param thirdId
     * @return
     */
    private String getThirdName(String thirdId) {
        String thirdName = null;
        switch (thirdId) {
            case "thirdId":
                thirdName = "thirdName";
                break;
            case "thirdId1":
                thirdName = "thirdName1";
                break;
            case "thirdId2":
                thirdName = "thirdName2";
                break;
            case "thirdId3":
                thirdName = "thirdName3";
                break;
            case "thirdId4":
                thirdName = "thirdName4";
                break;
            default:
                break;
        }
        return thirdName;
    }

    /**
     * @param thirdSysBusApiEntity
     * @return
     */
    private String getThirdId(BasicThirdSysBusApiEntity thirdSysBusApiEntity) {
        String thirdId = null;
        switch (thirdSysBusApiEntity.getThirdSys()) {
            case "thirdId":
                thirdId = "thirdId";
                break;
            case "third1":
                thirdId = "thirdId1";
                break;
            case "third2":
                thirdId = "thirdId2";
                break;
            case "third3":
                thirdId = "thirdId3";
                break;
            case "third4":
                thirdId = "thirdId4";
                break;
            default:
                break;
        }
        return thirdId;
    }

}
