package com.glxp.mipsdl.admin.config;

import com.glxp.mipsdl.admin.dao.config.ThrConfigDao;
import com.glxp.mipsdl.admin.entity.config.ThrPartConfig;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Configuration;

import javax.annotation.PostConstruct;
import java.net.URLEncoder;

@Slf4j
@Configuration
public class UdPlatConfig {

    @Autowired
    private ThrConfigDao thrConfigDao;

    private ThrPartConfig udPlatConfig;

    @PostConstruct
    public void initConfig() {
        this.udPlatConfig = thrConfigDao.selectByPartName("udplat");
    }

    public ThrPartConfig getUdPlatConfig() {
        return udPlatConfig;
    }

    public String getHost() {
        return udPlatConfig.getHost();
    }

    public String getAppId() {
        return udPlatConfig.getAppId();
    }

    public String getSecretKey() {
        return udPlatConfig.getSecretKey();
    }

    /**
     * 返回经过编码的用户名
     *
     * @return
     */
    public String getUserName() {
        try {
            return URLEncoder.encode(udPlatConfig.getUserName(), "UTF-8");
        } catch (Exception e) {
            log.error("用户名编码异常", e);
            return "";
        }
    }

    public String getPartName() {
        return udPlatConfig.getPartName();
    }

}
