package com.glxp.mipsdl.admin.controller;

import com.glxp.mipsdl.admin.client.file.GlxpFileClient;
import com.glxp.mipsdl.admin.client.file.PhxyyFileClient;
import com.glxp.mipsdl.admin.client.file.YGUdplatFileClient;
import com.glxp.mipsdl.admin.client.file.ZyV1FileClient;
import com.glxp.mipsdl.common.res.BaseResponse;
import com.glxp.mipsdl.common.util.ResultVOUtils;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import java.util.List;

@RestController
public class UdiInfoUploadController {

    @Value("${FILE_VERSION_FLAG}")
    private String curFlag;

    @Resource
    GlxpFileClient pzhzdFileClient;
    @Resource
    ZyV1FileClient zahospFileClient;
    @Resource
    YGUdplatFileClient ygUdplatFileClient;
    @Resource
    PhxyyFileClient phxyyFileClient;

    //产品信息导入
    @PostMapping("/udiwms/erp/pi/upload")
    public BaseResponse uploadPi(@RequestParam("file") List<MultipartFile> files, @RequestParam("thirdSys") String thirdSys) {
        if (curFlag.equals("GLXP"))
            return pzhzdFileClient.uploadPi(files, thirdSys);
        else if (curFlag.equals("ZHIYE_V1")) {
            return zahospFileClient.uploadPi(files, thirdSys);
        } else if (curFlag.equals("YG_UDPLAT_V1")) {
            return ygUdplatFileClient.uploadPi(files, thirdSys);
        } else if (curFlag.equals("PHXYY")) {
            return phxyyFileClient.uploadPi(files, thirdSys);
        } else
            return ResultVOUtils.error(500, "未设置系统版本！");
    }

    //往来单位导入
    @PostMapping("/udiwms/erp/corp/upload")
    public BaseResponse uploadCorps(@RequestParam("file") List<MultipartFile> files, @RequestParam("thirdSys") String thirdSys) {

        if (curFlag.equals("GLXP"))
            return pzhzdFileClient.uploadCorps(files, thirdSys);
        else if (curFlag.equals("ZHIYE_V1")) {
//            return pzhzdFileClient.uploadCorps(files, thirdSys);
            return zahospFileClient.uploadCorps(files, thirdSys);
        } else if (curFlag.equals("YG_UDPLAT_V1")) {
            return ygUdplatFileClient.uploadCorps(files, thirdSys);
        } else if (curFlag.equals("PHXYY")) {
            return phxyyFileClient.uploadCorps(files, thirdSys);
        } else
            return ResultVOUtils.error(500, "未设置系统版本！");
    }

    //库存产品信息上传
    @PostMapping("/udiwms/erp/invpi/upload")
    public BaseResponse uploadInvPi(@RequestParam("file") List<MultipartFile> files, @RequestParam("thirdSys") String thirdSys) {
        if (curFlag.equals("GLXP"))
            return pzhzdFileClient.uploadInvPi(files, thirdSys);
        else if (curFlag.equals("ZHIYE_V1")) {
            return zahospFileClient.uploadInvPi(files, thirdSys);
        } else if (curFlag.equals("YG_UDPLAT_V1")) {
            return ygUdplatFileClient.uploadInvPi(files, thirdSys);
        } else if (curFlag.equals("PHXYY")) {
            return phxyyFileClient.uploadInvPi(files, thirdSys);
        } else
            return ResultVOUtils.error(500, "未设置系统版本！");
    }

    //业务单据上传
    @PostMapping("/udiwms/erp/order/upload")
    public BaseResponse uploadOrders(@RequestParam("file") List<MultipartFile> files, @RequestParam("thirdSys") String thirdSys) {
        if (curFlag.equals("GLXP"))
            return pzhzdFileClient.uploadOrders(files, thirdSys);
        else if (curFlag.equals("ZHIYE_V1")) {
            return zahospFileClient.uploadOrders(files, thirdSys);
        } else if (curFlag.equals("YG_UDPLAT_V1")) {
            return ygUdplatFileClient.uploadOrders(files, thirdSys);
        } else if (curFlag.equals("PHXYY")) {
            return phxyyFileClient.uploadOrders(files, thirdSys);
        } else
            return ResultVOUtils.error(500, "未设置系统版本！");
    }


}
