package com.glxp.mipsdl.admin.entity.ygudplat;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;

import java.util.Date;

@Data
public class UdplatGoodsEntity {
    private Long id;
    private String uuid;
    private String deliveryGoodsId;//配送目录ID/bigint
    private String projectGoodsCode;//联采目录编码/varchar(50)
    private String deliveryGoodsCode;//配送目录编码/varchar(50)
    private String manufactureId;//平台生产企业ID/bigint(20)
    private String manufactureName;//平台生产企业名称/varchar(50)
    private String distributorId; //平台配送企业ID/bigint(20)
    private String distributorName;//平台配送企业名称/varchar(50)
    private String productName; //产品通用名/varchar(255)
    private String compId; //组件id/bigint
    private String model;//型号/varchar(1000)
    private String spec;//规格/varchar(1000)
    private String prodMaterial;//材质/varchar(255)
    private String packMaterial;//包材/varchar(255)
    private String regNum;//注册证编号/varchar(255)
    private String regName;//注册证名称/varchar(255)
    private Date regValidTo;//注册证有效期截止时间/varchar(255)
    private String unionProjectId;//联采项目ID/bigint(20)
    private String unionProjectName;//采购项目名称/varchar(255)
    private double salePrice;//价格/decimal(18,4)
    private String priceUnitText;//价格单位/varchar(100)
    private double topSalePrice;//最高销售限价，可能为空/decimal(18,4)
    private double settlePayPrice;//医保支付标准，可能为空/varchar(255)
    private String goodsSource;//数据来源/int(11)(取值：1.集中采购 2.耗材联采 3.医院HIS/医疗机构新增 4.备案采购 9. 阳光采购10. 新型冠状病毒相关检测试剂省级集中采购14. 限新冠病毒核酸快速检测采购使用)
    private String stockStatus;//缺货状态（1有货、2缺货）/int
    private String changedContent;//更新内容
    private Date changedTime;//更新时间
    private String proxyName;//申报企业名称/ varchar(50)
    private String onlineStatus;//挂网状态  1挂网2挂网状态为空 6 撤销申报
    private String medicalCode;//医保编码
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date createTime;//创建时间
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date updateTime;//最后更新时间

    private Integer matchLevel; //对照层级 1.产品 2.单一规格

    private String hospHisCode;

}
