package com.glxp.mipsdl.admin.http;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.TypeReference;
import com.glxp.mipsdl.admin.http.request.UCustmandocRequest;
import com.glxp.mipsdl.admin.http.request.UInvmandocRequest;
import com.glxp.mipsdl.admin.http.response.UCustmandocResponse;
import com.glxp.mipsdl.admin.http.response.UInvmandocQueryResponse;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.web.client.RestTemplate;

import java.util.List;

public class UCloudBasicClient {

    private static final Logger logger = LoggerFactory.getLogger(UCloudBasicClient.class);
    private String u8Url;
    HttpHeaders headers;

    public UCloudBasicClient(String u8Url, HttpHeaders headers) {
        this.u8Url = u8Url;
        this.headers = headers;
    }

//    public HttpHeaders getNewHeads() {
//        HttpHeaders headers = new HttpHeaders();
//        headers.add("Content-Type", "application/json; charset=UTF-8");
//        headers.add("system", "01");
//        headers.add("usercode", "udi1");
//        headers.add("password", "c4ca4238a0b923820dcc509a6f75849b");
//        headers.add("trantype", "code");
//        return headers;
//    }


    //客商管理档案查询
    public UBaseResponse custmandocQuery(UCustmandocRequest custmandocRequest) {
        String url = u8Url + "/u8cloud/api/uapbd/custmandoc/query";
        RestTemplate restTemplate = new RestTemplate();
        String params = JSONObject.toJSON(custmandocRequest).toString();
        logger.info(url + "\n" + params);
        HttpEntity<String> httpEntity = new HttpEntity<>(params, headers);
        String responseStr = restTemplate.postForObject(url, httpEntity, String.class);

        responseStr = UHttpUtils.formatResponse(responseStr);
        UBaseResponse<List<UCustmandocResponse>> response;
        try {
            response = JSONObject.parseObject(responseStr, new TypeReference<UBaseResponse<List<UCustmandocResponse>>>() {
            });
            return response;
        } catch (Exception e) {
        }
        return UHttpUtils.returnError();
    }

    //存货管理档案查询
    public UBaseResponse invmandocQuery(UInvmandocRequest uInvmandocRequest) {
        String url = u8Url + "/u8cloud/api/uapbd/invmandoc/query";
        RestTemplate restTemplate = new RestTemplate();
        String params = JSONObject.toJSON(uInvmandocRequest).toString();
        logger.info(url + "\n" + params);
        HttpEntity<String> httpEntity = new HttpEntity<>(params, headers);
        String responseStr = restTemplate.postForObject(url, httpEntity, String.class);
        responseStr = UHttpUtils.formatResponse(responseStr);
        UBaseResponse<List<UInvmandocQueryResponse>> response;
        try {
            response = JSONObject.parseObject(responseStr, new TypeReference<UBaseResponse<List<UInvmandocQueryResponse>>>() {
            });
            return response;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return UHttpUtils.returnError();
    }


}
