package com.glxp.mipsdl.admin.http;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.TypeReference;
import com.glxp.mipsdl.admin.http.request.*;
import com.glxp.mipsdl.admin.http.response.UOnhandQueryResponse;
import com.glxp.mipsdl.admin.http.response.UPurchaseinQueryResponse;
import com.glxp.mipsdl.admin.http.response.USaleoutQueryResponse;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.web.client.RestTemplate;

import java.util.List;

public class UCloudStockClient {
    private static final Logger logger = LoggerFactory.getLogger(UCloudStockClient.class);

    private String u8Url;
    HttpHeaders headers;

    public UCloudStockClient(String u8Url, HttpHeaders headers) {
        this.u8Url = u8Url;
        this.headers = headers;
    }


    public HttpHeaders getNewHeads() {
        HttpHeaders headers = new HttpHeaders();
        headers.add("Content-Type", "application/json; charset=UTF-8");
        headers.add("system", "01");
        headers.add("usercode", "udi1");
        headers.add("password", "c4ca4238a0b923820dcc509a6f75849b");
        headers.add("trantype", "code");
        return headers;
    }

    //采购入库单查询
    public UBaseResponse purchaseinQuery(UPurchaseinRequest uPurchaseinRequest) {
        String url = u8Url + "/u8cloud/api/ic/purchasein/query";
        RestTemplate restTemplate = new RestTemplate();
        String params = JSONObject.toJSON(uPurchaseinRequest).toString();
        logger.info(url + "\n" + params);
        HttpEntity<String> httpEntity = new HttpEntity<>(params, headers);
        String responseStr = restTemplate.postForObject(url, httpEntity, String.class);
        responseStr = UHttpUtils.formatResponse(responseStr);
        UBaseResponse<List<UPurchaseinQueryResponse>> response;
        try {
            response = JSONObject.parseObject(responseStr, new TypeReference<UBaseResponse<List<UPurchaseinQueryResponse>>>() {
            });
            return response;
        } catch (Exception e) {
        }
        return UHttpUtils.returnError();
    }

    //销售出库单查询
    public UBaseResponse saleoutQuery(USaleoutQueryRequest uSaleoutQueryRequest) {
        String url = u8Url + "/u8cloud/api/ic/saleout/query";
        RestTemplate restTemplate = new RestTemplate();
        String params = JSONObject.toJSON(uSaleoutQueryRequest).toString();
        logger.info(url + "\n" + params);
        HttpEntity<String> httpEntity = new HttpEntity<>(params, headers);
        String responseStr = restTemplate.postForObject(url, httpEntity, String.class);
        responseStr = UHttpUtils.formatResponse(responseStr);
//        logger.info(responseStr);
        UBaseResponse<List<USaleoutQueryResponse>> response;
        try {
            response = JSONObject.parseObject(responseStr, new TypeReference<UBaseResponse<List<USaleoutQueryResponse>>>() {
            });
            return response;
        } catch (Exception e) {
        }
        return UHttpUtils.returnError();
    }

    //采购入库单修改
    public UBaseResponse purchaseinModify(ModifyPruchaseinRequest modifyPruchaseinRequest) {
        String url = u8Url + "/u8cloud/api/ic/purchasein/update";
        RestTemplate restTemplate = new RestTemplate();
        String params = JSONObject.toJSON(modifyPruchaseinRequest).toString();
        logger.info(url + "\n" + params);
        HttpEntity<String> httpEntity = new HttpEntity<>(params, headers);
        String responseStr = restTemplate.postForObject(url, httpEntity, String.class);
        UBaseResponse response = null;
        try {
            String body = JSONObject.toJSONString(responseStr);
            Object parse1 = JSON.parse(body);
            String s = parse1.toString();
            JSONObject jsonObject = JSON.parseObject(s);
            if (jsonObject.getString("status").equals("success")) {
                response = new UBaseResponse();
                response.setStatus("success");
            } else
                responseStr = UHttpUtils.formatResponse(responseStr);
            response = JSONObject.parseObject(responseStr, new TypeReference<UBaseResponse>() {
            });
        } catch (Exception e) {
            e.printStackTrace();
        }
//        logger.info(responseStr);
        return response;
    }


    //销售出库单修改
    public UBaseResponse saleModify(ModifyPruchaseinRequest modifyPruchaseinRequest) {
        String url = u8Url + "/u8cloud/api/ic/saleout/update";
        RestTemplate restTemplate = new RestTemplate();
        String params = JSONObject.toJSON(modifyPruchaseinRequest).toString();
        logger.info(url + "\n" + params);
        HttpEntity<String> httpEntity = new HttpEntity<>(params, headers);
        String responseStr = restTemplate.postForObject(url, httpEntity, String.class);
        UBaseResponse response = null;
        try {
            String body = JSONObject.toJSONString(responseStr);
            Object parse1 = JSON.parse(body);
            String s = parse1.toString();
            JSONObject jsonObject = JSON.parseObject(s);
            if (jsonObject.getString("status").equals("success")) {
                response = new UBaseResponse();
                response.setStatus("success");
            } else
                responseStr = UHttpUtils.formatResponse(responseStr);
            response = JSONObject.parseObject(responseStr, new TypeReference<UBaseResponse>() {
            });
        } catch (Exception e) {
            e.printStackTrace();
        }
        logger.info(responseStr);
        return response;
    }

    //采购入库单签字
    public UBaseResponse purchaseinSign(UPurhaseinSignRequest purhaseinSignRequest) {
        String url = u8Url + "/u8cloud/api/ic/purchasein/sign";
        RestTemplate restTemplate = new RestTemplate();
        String params = JSONObject.toJSON(purhaseinSignRequest).toString();
        logger.info(url + "\n" + params);
        HttpEntity<String> httpEntity = new HttpEntity<>(params, headers);
        String responseStr = restTemplate.postForObject(url, httpEntity, String.class);
        responseStr = UHttpUtils.formatResponse(responseStr);
        UBaseResponse response = null;
        try {
            JSONObject jsonObject = JSON.parseObject(responseStr);
            if (jsonObject.getString("status").equals("success")) {
                response = new UBaseResponse();
                response.setStatus("success");
            } else
                response = JSONObject.parseObject(responseStr, new TypeReference<UBaseResponse>() {
                });
        } catch (Exception e) {
            e.printStackTrace();
        }
        logger.info(responseStr);
        return response;
    }

    //销售出库单签字
    public UBaseResponse saleOutSign(USaleoutSignRequest saleoutSignRequest) {
        String url = u8Url + "/u8cloud/api/ic/saleout/sign";
        RestTemplate restTemplate = new RestTemplate();
        String params = JSONObject.toJSON(saleoutSignRequest).toString();
        logger.info(url + "\n" + params);
        HttpEntity<String> httpEntity = new HttpEntity<>(params, headers);
        String responseStr = restTemplate.postForObject(url, httpEntity, String.class);

        responseStr = UHttpUtils.formatResponse(responseStr.trim());
        UBaseResponse response = null;
        try {
            JSONObject jsonObject = JSON.parseObject(responseStr);
            if (jsonObject.getString("status").equals("success")) {
                response = new UBaseResponse();
                response.setStatus("success");
            } else
                response = JSONObject.parseObject(responseStr, UBaseResponse.class);
        } catch (Exception e) {
            e.printStackTrace();
        }
        logger.info(responseStr);
        return response;
    }

    //现存量查询
    public UBaseResponse onhandQuery(UOnhandQueryRequest onhandQueryRequest) {
        String url = u8Url + "/u8cloud/api/ic/onhand/query";
        RestTemplate restTemplate = new RestTemplate();
        String params = JSONObject.toJSON(onhandQueryRequest).toString();
        logger.info(url + "\n" + params);
        HttpEntity<String> httpEntity = new HttpEntity<>(params, headers);
        String responseStr = restTemplate.postForObject(url, httpEntity, String.class);
        responseStr = UHttpUtils.formatResponse(responseStr);
//        logger.info(responseStr);
        UBaseResponse<List<UOnhandQueryResponse>> response;
        try {
            response = JSONObject.parseObject(responseStr, new TypeReference<UBaseResponse<List<UOnhandQueryResponse>>>() {
            });
            return response;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return UHttpUtils.returnError();
    }

    //现存量查询
    public UBaseResponse onhandQueryPost(UOnhandPostQueryRequest onhandQueryRequest) {
        String url = u8Url + "/u8cloud/api/ic/onhand/query";
        RestTemplate restTemplate = new RestTemplate();
        String params = JSONObject.toJSON(onhandQueryRequest).toString();
        logger.info(url + "\n" + params);
        HttpEntity<String> httpEntity = new HttpEntity<>(params, headers);
        String responseStr = restTemplate.postForObject(url, httpEntity, String.class);
        responseStr = UHttpUtils.formatResponse(responseStr);
//        logger.info(responseStr);
        UBaseResponse<List<UOnhandQueryResponse>> response;
        try {
            response = JSONObject.parseObject(responseStr, new TypeReference<UBaseResponse<List<UOnhandQueryResponse>>>() {
            });
            return response;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return UHttpUtils.returnError();
    }

}