package com.glxp.mipsdl.admin.util;

import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson.JSONObject;
import com.glxp.mipsdl.admin.http.OkHttpCli;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.client.SimpleClientHttpRequestFactory;
import org.springframework.stereotype.Service;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;
import org.springframework.web.client.RestTemplate;

import javax.annotation.Resource;

@Service
public class HttpClient {

    @Resource
    OkHttpCli okHttpCli;

    private final Logger logger = LoggerFactory.getLogger(HttpClient.class);

    public String post(String url, Object object) {
        RestTemplate restTemplate = new RestTemplate();
        String json = JSONObject.toJSON(object).toString();
        MultiValueMap<String, Object> postParameters = new LinkedMultiValueMap<>();
        postParameters.add("params", json);
        HttpHeaders headers = new HttpHeaders();
        headers.add("Content-Type", "application/x-www-form-urlencoded");
        HttpEntity<MultiValueMap<String, Object>> httpEntity = new HttpEntity<>(postParameters, headers);
        String response = restTemplate.postForObject(UdidConfig.apiUrl + url, httpEntity, String.class);
        System.out.println(response);

        return response;
    }

    public String postJson(String url, Object object) {
        SimpleClientHttpRequestFactory factory = new SimpleClientHttpRequestFactory();
        factory.setConnectTimeout(600000);
        factory.setReadTimeout(600000);
        RestTemplate restTemplate = new RestTemplate(factory);
        String json = JSONObject.toJSON(object).toString();
        HttpHeaders headers = new HttpHeaders();
        headers.add("Content-Type", "application/json");
        HttpEntity<String> httpEntity = new HttpEntity<>(json, headers);
        String response = restTemplate.postForObject(url, httpEntity, String.class);
        logger.info(response);
        return response;
    }


    public String postJson(String url, Object object, HttpHeaders headers) {
        SimpleClientHttpRequestFactory factory = new SimpleClientHttpRequestFactory();
        factory.setConnectTimeout(600000);
        factory.setReadTimeout(600000);
        RestTemplate restTemplate = new RestTemplate(factory);
        String json = JSONObject.toJSON(object).toString();
        logger.info(url + "\n" + json);
        HttpEntity<String> httpEntity = new HttpEntity<>(json, headers);
        String response = restTemplate.postForObject(url, httpEntity, String.class);
        logger.info(response);
        return response;
    }


    public String postJson(String url, Object object, String... headers) {
        String json = JSONObject.toJSON(object).toString();
        logger.info(url + "\n" + json);
        String response = okHttpCli.doPostJson(url, json, headers);
        logger.error(response);
        if (StrUtil.isEmpty(response)) {

        }
        return response;
    }

}
